/*======================================================================================

	Program:		Range Imaging Toolkit (RITK)
	Module:			ritkAbstractFactory.h
	Version:		$Revision: 1761 $
	Date:			$Date: 2011-09-23 17:25:41 +0200 (Fri, 23 Sep 2011) $

	Copyright (c) 2010-2011
	Pattern Recognition Lab, 
    University Erlangen-Nuremberg, Germany
    All rights reserved.

	This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
	See RITKCopyright.txt for more information.

	http://www5.informatik.uni-erlangen.de/research/software/ritk

========================================================================================*/

#ifndef ABSTRACTFACTORY_H__
#define ABSTRACTFACTORY_H__

namespace ritk
{

/**	@ingroup	Core
 *	@class		AbstractFactory
 *	@author		Jakob Wasza
 *	@brief		Factory design pattern
 *
 *	@details
 *	Abstract factory design pattern
 */
template<class T>
class AbstractFactory
{
public:
	/// Destructor
	virtual ~AbstractFactory() {}

	/// Create an instance of the template
	virtual T* CreateInstance() = 0;
};


} // end namespace ritk

#endif //ABSTRACTFACTORY_H__